package flm.b4a.gesturedemo;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "flm.b4a.gesturedemo", "flm.b4a.gesturedemo.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "flm.b4a.gesturedemo", "flm.b4a.gesturedemo.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "flm.b4a.gesturedemo.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public flm.b4a.gesturedetector.GestureDetectorForB4A _gd = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlgreen = null;
public static int _ptrdown = 0;
public static boolean _isdragallowed = false;
public anywheresoftware.b4a.agraham.reflection.Reflection _r = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
 //BA.debugLineNum = 26;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 27;BA.debugLine="Dim lbl As Label";
_lbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 28;BA.debugLine="lbl.Initialize(\"\")";
_lbl.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 29;BA.debugLine="lbl.Text = \"Move the green ball with the finger.\"";
_lbl.setText(BA.ObjectToCharSequence("Move the green ball with the finger."));
 //BA.debugLineNum = 30;BA.debugLine="lbl.TextColor = Colors.White";
_lbl.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 31;BA.debugLine="lbl.TextSize = 18";
_lbl.setTextSize((float) (18));
 //BA.debugLineNum = 32;BA.debugLine="Activity.AddView(lbl, 15dip, 15dip, 100%x-30dip,";
mostCurrent._activity.AddView((android.view.View)(_lbl.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (15)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (15)),(int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60)));
 //BA.debugLineNum = 34;BA.debugLine="pnlGreen.Initialize(\"\")";
mostCurrent._pnlgreen.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 35;BA.debugLine="pnlGreen.SetBackgroundImage(LoadBitmap(File.DirAs";
mostCurrent._pnlgreen.SetBackgroundImageNew((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"greenball.png").getObject()));
 //BA.debugLineNum = 36;BA.debugLine="Activity.AddView(pnlGreen, 30dip, 70dip, 100dip,";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlgreen.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (70)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)));
 //BA.debugLineNum = 37;BA.debugLine="GD.SetOnGestureListener(pnlGreen, \"Gesture\")";
mostCurrent._gd.SetOnGestureListener(processBA,(android.view.View)(mostCurrent._pnlgreen.getObject()),"Gesture");
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 43;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 41;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_ondrag(float _deltax,float _deltay,Object _motionevent) throws Exception{
 //BA.debugLineNum = 58;BA.debugLine="Sub Gesture_onDrag(deltaX As Float, deltaY As Floa";
 //BA.debugLineNum = 59;BA.debugLine="If PtrDown = 0 Then";
if (_ptrdown==0) { 
 //BA.debugLineNum = 60;BA.debugLine="IsDragAllowed=True";
_isdragallowed = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 61;BA.debugLine="Log(\"   onDrag deltaX = \" & deltaX & \", deltaY =";
anywheresoftware.b4a.keywords.Common.Log("   onDrag deltaX = "+BA.NumberToString(_deltax)+", deltaY = "+BA.NumberToString(_deltay)+", ev = "+BA.ObjectToString(_motionevent));
 //BA.debugLineNum = 62;BA.debugLine="pnlGreen.Left = Max(0, Min(pnlGreen.Left + delta";
mostCurrent._pnlgreen.setLeft((int) (anywheresoftware.b4a.keywords.Common.Max(0,anywheresoftware.b4a.keywords.Common.Min(mostCurrent._pnlgreen.getLeft()+_deltax,anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._pnlgreen.getWidth()))));
 //BA.debugLineNum = 63;BA.debugLine="pnlGreen.Top = Max(0, Min(pnlGreen.Top + deltaY,";
mostCurrent._pnlgreen.setTop((int) (anywheresoftware.b4a.keywords.Common.Max(0,anywheresoftware.b4a.keywords.Common.Min(mostCurrent._pnlgreen.getTop()+_deltay,anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._pnlgreen.getHeight()))));
 };
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpinchclose(float _newdistance,float _previousdistance,Object _motionevent) throws Exception{
 //BA.debugLineNum = 114;BA.debugLine="Sub Gesture_onPinchClose(NewDistance As Float, Pre";
 //BA.debugLineNum = 115;BA.debugLine="Log(\"   onPinchClose dist=\" & NewDistance & \", pr";
anywheresoftware.b4a.keywords.Common.Log("   onPinchClose dist="+BA.NumberToString(_newdistance)+", prevdist="+BA.NumberToString(_previousdistance)+", ev="+BA.ObjectToString(_motionevent));
 //BA.debugLineNum = 116;BA.debugLine="ResizePanel(MotionEvent)";
_resizepanel(_motionevent);
 //BA.debugLineNum = 117;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpinchopen(float _newdistance,float _previousdistance,Object _motionevent) throws Exception{
 //BA.debugLineNum = 110;BA.debugLine="Sub Gesture_onPinchOpen(NewDistance As Float, Prev";
 //BA.debugLineNum = 111;BA.debugLine="Log(\"   onPinchOpen dist=\" & NewDistance & \", pre";
anywheresoftware.b4a.keywords.Common.Log("   onPinchOpen dist="+BA.NumberToString(_newdistance)+", prevdist="+BA.NumberToString(_previousdistance)+", ev="+BA.ObjectToString(_motionevent));
 //BA.debugLineNum = 112;BA.debugLine="ResizePanel(MotionEvent)";
_resizepanel(_motionevent);
 //BA.debugLineNum = 113;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpointerdown(int _ptrindex,int _pid,Object _motionevent) throws Exception{
 //BA.debugLineNum = 92;BA.debugLine="Sub Gesture_onPointerDown(ptrIndex As Int, PID As";
 //BA.debugLineNum = 93;BA.debugLine="Log(\"onPointerDown ptrindex=\" & ptrIndex & \", pid";
anywheresoftware.b4a.keywords.Common.Log("onPointerDown ptrindex="+BA.NumberToString(_ptrindex)+", pid="+BA.NumberToString(_pid)+", ev="+BA.ObjectToString(_motionevent));
 //BA.debugLineNum = 94;BA.debugLine="ResizePanel(MotionEvent)";
_resizepanel(_motionevent);
 //BA.debugLineNum = 95;BA.debugLine="IsDragAllowed=False";
_isdragallowed = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 96;BA.debugLine="PtrDown = PtrDown + 1";
_ptrdown = (int) (_ptrdown+1);
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpointerup(int _ptrindex,int _pid,Object _motionevent) throws Exception{
 //BA.debugLineNum = 100;BA.debugLine="Sub Gesture_onPointerUp(ptrIndex As Int, PID As In";
 //BA.debugLineNum = 101;BA.debugLine="Log(\"onPointerUp ptrindex=\" & ptrIndex & \", pid=\"";
anywheresoftware.b4a.keywords.Common.Log("onPointerUp ptrindex="+BA.NumberToString(_ptrindex)+", pid="+BA.NumberToString(_pid)+", ev="+BA.ObjectToString(_motionevent));
 //BA.debugLineNum = 102;BA.debugLine="PtrDown = PtrDown - 1";
_ptrdown = (int) (_ptrdown-1);
 //BA.debugLineNum = 105;BA.debugLine="IsDragAllowed=True";
_isdragallowed = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 108;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onrotation(double _degrees,Object _motionevent) throws Exception{
 //BA.debugLineNum = 119;BA.debugLine="Sub Gesture_onRotation(Degrees As Double, MotionEv";
 //BA.debugLineNum = 120;BA.debugLine="Log(\"   onRotation degrees=\" & Degrees & \", ev=\"";
anywheresoftware.b4a.keywords.Common.Log("   onRotation degrees="+BA.NumberToString(_degrees)+", ev="+BA.ObjectToString(_motionevent));
 //BA.debugLineNum = 121;BA.debugLine="If pnlGreen.Width > 0 And pnlGreen.Height > 0 The";
if (mostCurrent._pnlgreen.getWidth()>0 && mostCurrent._pnlgreen.getHeight()>0) { 
 //BA.debugLineNum = 123;BA.debugLine="setRotation(pnlGreen,Degrees)";
_setrotation((anywheresoftware.b4a.objects.ConcreteViewWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), (android.view.View)(mostCurrent._pnlgreen.getObject())),(float) (_degrees));
 };
 //BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static boolean  _gesture_ontouch(int _action,float _x,float _y,Object _motionevent) throws Exception{
 //BA.debugLineNum = 46;BA.debugLine="Sub Gesture_onTouch(Action As Int, X As Float, Y A";
 //BA.debugLineNum = 47;BA.debugLine="If IsDragAllowed And Action =1 Then";
if (_isdragallowed && _action==1) { 
 //BA.debugLineNum = 49;BA.debugLine="Log(\"onTouch action=\" & Action & \", x=\" & X & \",";
anywheresoftware.b4a.keywords.Common.Log("onTouch action="+BA.NumberToString(_action)+", x="+BA.NumberToString(_x)+", y="+BA.NumberToString(_y)+", ev="+BA.ObjectToString(_motionevent));
 //BA.debugLineNum = 50;BA.debugLine="Log(\"onTouch ScreenX=\" & (X+pnlGreen.Left) & \",";
anywheresoftware.b4a.keywords.Common.Log("onTouch ScreenX="+BA.NumberToString((_x+mostCurrent._pnlgreen.getLeft()))+", ScreenY="+BA.NumberToString((_y+mostCurrent._pnlgreen.getTop())));
 };
 //BA.debugLineNum = 56;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return false;
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim GD As GestureDetector";
mostCurrent._gd = new flm.b4a.gesturedetector.GestureDetectorForB4A();
 //BA.debugLineNum = 19;BA.debugLine="Dim pnlGreen As Panel";
mostCurrent._pnlgreen = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 20;BA.debugLine="Dim PtrDown As Int";
_ptrdown = 0;
 //BA.debugLineNum = 21;BA.debugLine="Dim IsDragAllowed As Boolean";
_isdragallowed = false;
 //BA.debugLineNum = 22;BA.debugLine="Dim R As Reflector";
mostCurrent._r = new anywheresoftware.b4a.agraham.reflection.Reflection();
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return "";
}
public static String  _resizepanel(Object _motionevent) throws Exception{
int _left = 0;
int _top = 0;
int _width = 0;
int _height = 0;
int _screenx0 = 0;
int _screenx1 = 0;
int _screeny0 = 0;
int _screeny1 = 0;
double _panelproportion = 0;
 //BA.debugLineNum = 67;BA.debugLine="Sub ResizePanel(MotionEvent As Object)";
 //BA.debugLineNum = 68;BA.debugLine="Dim Left, Top, Width, Height As Int";
_left = 0;
_top = 0;
_width = 0;
_height = 0;
 //BA.debugLineNum = 69;BA.debugLine="Dim ScreenX0 As Int = pnlGreen.Left + GD.getX(Mot";
_screenx0 = (int) (mostCurrent._pnlgreen.getLeft()+mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (0)));
 //BA.debugLineNum = 70;BA.debugLine="Dim ScreenX1 As Int = pnlGreen.Left + GD.getX(Mot";
_screenx1 = (int) (mostCurrent._pnlgreen.getLeft()+mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (1)));
 //BA.debugLineNum = 71;BA.debugLine="If ScreenX0 > ScreenX1 Then";
if (_screenx0>_screenx1) { 
 //BA.debugLineNum = 72;BA.debugLine="Left = ScreenX1";
_left = _screenx1;
 }else {
 //BA.debugLineNum = 74;BA.debugLine="Left = ScreenX0";
_left = _screenx0;
 };
 //BA.debugLineNum = 76;BA.debugLine="Dim ScreenY0 As Int = pnlGreen.Top + GD.getY(Moti";
_screeny0 = (int) (mostCurrent._pnlgreen.getTop()+mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (0)));
 //BA.debugLineNum = 77;BA.debugLine="Dim ScreenY1 As Int = pnlGreen.Top + GD.getY(Moti";
_screeny1 = (int) (mostCurrent._pnlgreen.getTop()+mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (1)));
 //BA.debugLineNum = 78;BA.debugLine="If ScreenY0 > ScreenY1 Then";
if (_screeny0>_screeny1) { 
 //BA.debugLineNum = 79;BA.debugLine="Top = ScreenY1";
_top = _screeny1;
 }else {
 //BA.debugLineNum = 81;BA.debugLine="Top = ScreenY0";
_top = _screeny0;
 };
 //BA.debugLineNum = 83;BA.debugLine="Dim PanelProportion As Double = pnlGreen.Width/pn";
_panelproportion = mostCurrent._pnlgreen.getWidth()/(double)mostCurrent._pnlgreen.getHeight();
 //BA.debugLineNum = 85;BA.debugLine="Width = Abs(ScreenX0 - ScreenX1)";
_width = (int) (anywheresoftware.b4a.keywords.Common.Abs(_screenx0-_screenx1));
 //BA.debugLineNum = 86;BA.debugLine="Height = Abs(ScreenY0 - ScreenY1)";
_height = (int) (anywheresoftware.b4a.keywords.Common.Abs(_screeny0-_screeny1));
 //BA.debugLineNum = 88;BA.debugLine="Width = Height * PanelProportion";
_width = (int) (_height*_panelproportion);
 //BA.debugLineNum = 89;BA.debugLine="pnlGreen.SetLayout(Left, Top, Width, Height)";
mostCurrent._pnlgreen.SetLayout(_left,_top,_width,_height);
 //BA.debugLineNum = 90;BA.debugLine="End Sub";
return "";
}
public static String  _setrotation(anywheresoftware.b4a.objects.ConcreteViewWrapper _v,float _angle) throws Exception{
 //BA.debugLineNum = 127;BA.debugLine="Sub setRotation(v As View, Angle As Float)";
 //BA.debugLineNum = 130;BA.debugLine="End Sub";
return "";
}
}
